我是靠谱客的博主 冷傲鲜花,最近开发中收集的这篇文章主要介绍leetcode之最大矩形C++解法,觉得挺不错的,现在分享给大家,希望可以做个参考。

概述

leetcode之最大矩形C++解法

给定一个仅包含 0 和 1 的二维二进制矩阵,找出只包含 1 的最大矩形,并返回其面积。

输入:
[
["1","0","1","0","0"],
["1","0","1","1","1"],
["1","1","1","1","1"],
["1","0","0","1","0"]
]
输出: 6

道题的二维矩阵每一层向上都可以看做一个直方图,输入矩阵有多少行,就可以形成多少个直方图,对每个直方图都调用 Largest Rectangle in Histogram 中的方法,就可以得到最大的矩形面积。那么这道题唯一要做的就是将每一层都当作直方图的底层,并向上构造整个直方图,由于题目限定了输入矩阵的字符只有 ‘0’ 和 ‘1’ 两种,所以处理起来也相对简单。方法是,对于每一个点,如果是 ‘0’,则赋0,如果是 ‘1’,就赋之前的 height 值加上1。
这道题可以转化成上一篇文章里的柱状图的矩形面积问题,m*n的矩阵可以看成n组柱状图分别进行处理。只需要额外计算每组柱状图的各个“柱子”的高度即可。
计算魅族柱状图的各个柱子的高度

for(int i=0;i<matrix.size();i++)
for(int j=0;j<matrix[i].size();j++)
h[j] = matrix[i][j]=='0'? 0:(h[j]+1);

对于题示中的矩阵来说,可求得高度矩阵:

[
[ 1, 0, 1, 0, 0 ],
[ 2, 0, 2, 1, 1 ],
[ 3, 1, 3, 2, 2 ],
[ 4, 0, 0, 3, 0 ]
]

对每一行数组调用柱状图的矩形面积问题的结果即可,最后每组柱状图的结果之间再进行比较得出最终结果。

完整代码:

class Solution {
public:
int maximalRectangle(vector<vector<char> > &matrix) {
int res = 0;
vector<int> height;
for (int i = 0; i < matrix.size(); ++i) {
height.resize(matrix[i].size());//再处理下一组数据之前将保存每组柱状图各个柱子高度的数组重新设置大小。
for (int j = 0; j < matrix[i].size(); ++j) {
height[j] = matrix[i][j] == '0' ? 0 : (1 + height[j]);
}
res = max(res, largestRectangleArea(height));
}
return res;
}
int largestRectangleArea(vector<int>& heights) {
if(heights.empty())
return 0;
stack<int> st;
heights.push_back(0);
int res0=0;
for(int i=0;i<heights.size();i++){
while(!st.empty()&&heights[i]<heights[st.top()]){
int curHeight = heights[st.top()];
st.pop();
int width = st.empty()? i : i - st.top() - 1;
if(width*curHeight>res0)
res0=width*curHeight;
}
st.push(i); //单调栈中放的是下标 而不是高度
}
return res0;
}
};

也可以把上面的代码卸载一个函数里:

class Solution {
public:
int maximalRectangle(vector<vector<char> > &matrix) {
int res = 0;
vector<int> height;
for (int i = 0; i < matrix.size(); ++i) {
height.resize(matrix[i].size());
for (int j = 0; j < matrix[i].size(); ++j) {
height[j] = matrix[i][j] == '0' ? 0 : (1 + height[j]);
}
//largestRectangleArea()
vector<int> heights=height;
if(heights.empty())
return 0;
stack<int> st;
heights.push_back(0);
int res0=0;
for(int i=0;i<heights.size();i++){
while(!st.empty()&&heights[i]<heights[st.top()]){
int curHeight = heights[st.top()];
st.pop();
int width = st.empty()? i : i - st.top() - 1;
if(width*curHeight>res0)
res0=width*curHeight;
}
st.push(i); //单调栈中放的是下标 而不是高度
}
res = max(res, res0); //对每组结果进行比较
}
return res;
}
};

最后

以上就是冷傲鲜花为你收集整理的leetcode之最大矩形C++解法的全部内容,希望文章能够帮你解决leetcode之最大矩形C++解法所遇到的程序开发问题。

如果觉得靠谱客网站的内容还不错,欢迎将靠谱客网站推荐给程序员好友。

本图文内容来源于网友提供,作为学习参考使用,或来自网络收集整理,版权属于原作者所有。
点赞(41)

评论列表共有 0 条评论

立即
投稿
返回
顶部